//---------------------------------------------------------------------------
// This file may be used in compiled form in any way you desire in personal
// or commercial applications. 

// This source code may be redistributed as long at it is not sold for 
// profit without notifying the author first, and providing that this notice 
// and the author's name remains in this file.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage whatsoever.
//
// Copyright 2002-2006 James Starling (pixelspop@hotmail.com)
//---------------------------------------------------------------------------

#if !defined(THYPERLINK_H__INCLUDED_)
#define THYPERLINK_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CJSHyperLink : public CStatic
{
public:
					CJSHyperLink(COLORREF crLink				= RGB(0,0,238), 
								COLORREF crClicked			= RGB(85,26,139), 
								COLORREF crHover			= RGB(255,0,0));

    void			SetURL(const CString& sURL);
    const CString&	GetURL() const;
	void			SetAlwaysUnderline(BOOL bAlwaysUnderline);
	const BOOL		GetAlwaysUnderline();

	void			SetLinkColor(COLORREF crLine);
	const COLORREF	GetLinkColor();
	
	void			SetHoverColor(COLORREF crHover);
	const COLORREF	GetHoverColor();

	void			SetClickedColor(COLORREF crClicked);
	const COLORREF	GetClickedColor();

    void			OpenURL();


protected:
    virtual BOOL	PreTranslateMessage(MSG* pMsg);
    virtual void	PreSubclassWindow();

    void			LoadHandCursor();
	void			InitTooltip();

    afx_msg void	OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void	OnPaint();

	LONG			GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);

    DECLARE_MESSAGE_MAP()

private:
    COLORREF		m_crLink;
    COLORREF		m_crClicked;
    COLORREF		m_crHover;
    BOOL			m_bHovering;
	BOOL			m_bClicked;
    int				m_nUnderline;
    CString			m_sURL;
    HCURSOR			m_hCursor;
    CToolTipCtrl	m_tooltip;
	BOOL			m_bAlwaysUnderline;
};

inline const CString&
CJSHyperLink::GetURL() const
{ 
    return m_sURL;
}
						 
inline const BOOL
CJSHyperLink::GetAlwaysUnderline()
{
	return(m_bAlwaysUnderline);
}

inline const COLORREF
CJSHyperLink::GetLinkColor()
{
	return(m_crLink);
}

inline const COLORREF
CJSHyperLink::GetHoverColor()
{
	return(m_crHover);
}

inline const COLORREF
CJSHyperLink::GetClickedColor()
{
	return(m_crClicked);
}

#endif // !defined(THYPERLINK_H__INCLUDED_)
